<?php
/**
 * Custom Functions.
 *
 * @package Spa Parlor
 */

if( !function_exists( 'spa_parlor_fonts_url' ) ) :

    //Google Fonts URL
    function spa_parlor_fonts_url(){

        $spa_parlor_font_families = array(
            'Montserrat:ital,wght@0,100..900;1,100..900', //   font-family: "Montserrat", sans-serif;
        );

        $spa_parlor_fonts_url = add_query_arg( array(
            'family' => implode( '&family=', $spa_parlor_font_families ),
            'display' => 'swap',
        ), 'https://fonts.googleapis.com/css2' );

        return esc_url_raw($spa_parlor_fonts_url);
    }

endif;

if ( ! function_exists( 'spa_parlor_sub_menu_toggle_button' ) ) :

    function spa_parlor_sub_menu_toggle_button( $spa_parlor_args, $spa_parlor_item, $depth ) {

        // Add sub menu toggles to the main menu with toggles
        if ( $spa_parlor_args->theme_location == 'spa-parlor-primary-menu' && isset( $spa_parlor_args->show_toggles ) ) {
            
            // Wrap the menu item link contents in a div, used for positioning
            $spa_parlor_args->before = '<div class="submenu-wrapper">';
            $spa_parlor_args->after  = '';

            // Add a toggle to items with children
            if ( in_array( 'menu-item-has-children', $spa_parlor_item->classes ) ) {

                $toggle_target_string = '.menu-item.menu-item-' . $spa_parlor_item->ID . ' > .sub-menu';

                // Add the sub menu toggle
                $spa_parlor_args->after .= '<button type="button" class="theme-aria-button submenu-toggle" data-toggle-target="' . $toggle_target_string . '" data-toggle-type="slidetoggle" data-toggle-duration="250" aria-expanded="false"><span class="btn__content" tabindex="-1"><span class="screen-reader-text">' . esc_html__( 'Show sub menu', 'spa-parlor' ) . '</span>' . spa_parlor_get_theme_svg( 'chevron-down' ) . '</span></button>';

            }

            // Close the wrapper
            $spa_parlor_args->after .= '</div><!-- .submenu-wrapper -->';
            // Add sub menu icons to the main menu without toggles (the fallback menu)

        }elseif( $spa_parlor_args->theme_location == 'spa-parlor-primary-menu' ) {

            if ( in_array( 'menu-item-has-children', $spa_parlor_item->classes ) ) {

                $spa_parlor_args->before = '<div class="link-icon-wrapper">';
                $spa_parlor_args->after  = spa_parlor_get_theme_svg( 'chevron-down' ) . '</div>';

            } else {

                $spa_parlor_args->before = '';
                $spa_parlor_args->after  = '';

            }

        }

        return $spa_parlor_args;

    }

endif;

add_filter( 'nav_menu_item_args', 'spa_parlor_sub_menu_toggle_button', 10, 3 );

if ( ! function_exists( 'spa_parlor_the_theme_svg' ) ):
    
    function spa_parlor_the_theme_svg( $spa_parlor_svg_name, $spa_parlor_return = false ) {

        if( $spa_parlor_return ){

            return spa_parlor_get_theme_svg( $spa_parlor_svg_name ); //phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped -- Escaped in spa_parlor_get_theme_svg();.

        }else{

            echo spa_parlor_get_theme_svg( $spa_parlor_svg_name ); //phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped -- Escaped in spa_parlor_get_theme_svg();.

        }
    }

endif;

if ( ! function_exists( 'spa_parlor_get_theme_svg' ) ):

    function spa_parlor_get_theme_svg( $spa_parlor_svg_name ) {

        // Make sure that only our allowed tags and attributes are included.
        $spa_parlor_svg = wp_kses(
            spa_parlor_SVG_Icons::get_svg( $spa_parlor_svg_name ),
            array(
                'svg'     => array(
                    'class'       => true,
                    'xmlns'       => true,
                    'width'       => true,
                    'height'      => true,
                    'viewbox'     => true,
                    'aria-hidden' => true,
                    'role'        => true,
                    'focusable'   => true,
                ),
                'path'    => array(
                    'fill'      => true,
                    'fill-rule' => true,
                    'd'         => true,
                    'transform' => true,
                ),
                'polygon' => array(
                    'fill'      => true,
                    'fill-rule' => true,
                    'points'    => true,
                    'transform' => true,
                    'focusable' => true,
                ),
                'polyline' => array(
                    'fill'      => true,
                    'points'    => true,
                ),
                'line' => array(
                    'fill'      => true,
                    'x1'      => true,
                    'x2' => true,
                    'y1'    => true,
                    'y2' => true,
                ),
            )
        );
        if ( ! $spa_parlor_svg ) {
            return false;
        }
        return $spa_parlor_svg;

    }

endif;

if( !function_exists( 'spa_parlor_post_category_list' ) ) :

    // Post Category List.
    function spa_parlor_post_category_list( $spa_parlor_select_cat = true ){

        $spa_parlor_post_cat_lists = get_categories(
            array(
                'hide_empty' => '0',
                'exclude' => '1',
            )
        );

        $spa_parlor_post_cat_cat_array = array();
        if( $spa_parlor_select_cat ){

            $spa_parlor_post_cat_cat_array[''] = esc_html__( '-- Select Category --','spa-parlor' );

        }

        foreach ( $spa_parlor_post_cat_lists as $spa_parlor_post_cat_list ) {

            $spa_parlor_post_cat_cat_array[$spa_parlor_post_cat_list->slug] = $spa_parlor_post_cat_list->name;

        }

        return $spa_parlor_post_cat_cat_array;
    }

endif;

if( !function_exists('spa_parlor_single_post_navigation') ):

    function spa_parlor_single_post_navigation(){

        $spa_parlor_default = spa_parlor_get_default_theme_options();
        $spa_parlor_twp_navigation_type = esc_attr( get_post_meta( get_the_ID(), 'twp_disable_ajax_load_next_post', true ) );
        $spa_parlor_current_id = '';
        $article_wrap_class = '';
        global $post;
        $spa_parlor_current_id = $post->ID;
        if( $spa_parlor_twp_navigation_type == '' || $spa_parlor_twp_navigation_type == 'global-layout' ){
            $spa_parlor_twp_navigation_type = get_theme_mod('twp_navigation_type', $spa_parlor_default['twp_navigation_type']);
        }

        if( $spa_parlor_twp_navigation_type != 'no-navigation' && 'post' === get_post_type() ){

            if( $spa_parlor_twp_navigation_type == 'theme-normal-navigation' ){ ?>

                <div class="navigation-wrapper">
                    <?php
                    // Previous/next post navigation.
                    the_post_navigation(array(
                        'prev_text' => '<span class="arrow" aria-hidden="true">' . spa_parlor_the_theme_svg('arrow-left',$spa_parlor_return = true ) . '</span><span class="screen-reader-text">' . esc_html__('Previous post:', 'spa-parlor') . '</span><span class="post-title">%title</span>',
                        'next_text' => '<span class="arrow" aria-hidden="true">' . spa_parlor_the_theme_svg('arrow-right',$spa_parlor_return = true ) . '</span><span class="screen-reader-text">' . esc_html__('Next post:', 'spa-parlor') . '</span><span class="post-title">%title</span>',
                    )); ?>
                </div>
                <?php

            }else{

                $spa_parlor_next_post = get_next_post();
                if( isset( $spa_parlor_next_post->ID ) ){

                    $spa_parlor_next_post_id = $spa_parlor_next_post->ID;
                    echo '<div loop-count="1" next-post="' . absint( $spa_parlor_next_post_id ) . '" class="twp-single-infinity"></div>';

                }
            }

        }

    }

endif;

add_action( 'spa_parlor_navigation_action','spa_parlor_single_post_navigation',30 );

if( !function_exists('spa_parlor_content_offcanvas') ):

    // Offcanvas Contents
    function spa_parlor_content_offcanvas(){ ?>

        <div id="offcanvas-menu">
            <div class="offcanvas-wraper">
                <div class="close-offcanvas-menu">
                    <div class="offcanvas-close">
                        <a href="javascript:void(0)" class="skip-link-menu-start"></a>
                        <button type="button" class="button-offcanvas-close">
                            <span class="offcanvas-close-label">
                                <?php echo esc_html__('Close', 'spa-parlor'); ?>
                            </span>
                        </button>
                    </div>
                </div>
                <div id="primary-nav-offcanvas" class="offcanvas-item offcanvas-main-navigation">
                    <nav class="primary-menu-wrapper" aria-label="<?php esc_attr_e('Horizontal', 'spa-parlor'); ?>" role="navigation">
                        <ul class="primary-menu theme-menu">
                            <?php
                            if (has_nav_menu('spa-parlor-primary-menu')) {
                                wp_nav_menu(
                                    array(
                                        'container' => '',
                                        'items_wrap' => '%3$s',
                                        'theme_location' => 'spa-parlor-primary-menu',
                                        'show_toggles' => true,
                                    )
                                );
                            }else{

                                wp_list_pages(
                                    array(
                                        'match_menu_classes' => true,
                                        'show_sub_menu_icons' => true,
                                        'title_li' => false,
                                        'show_toggles' => true,
                                        'walker' => new Spa_Parlor_Walker_Page(),
                                    )
                                );
                            }
                            ?>
                        </ul>
                    </nav><!-- .primary-menu-wrapper -->
                </div>
                <a href="javascript:void(0)" class="skip-link-menu-end"></a>
            </div>
        </div>

    <?php
    }

endif;

add_action( 'spa_parlor_before_footer_content_action','spa_parlor_content_offcanvas',30 );

if( !function_exists('spa_parlor_footer_content_widget') ):

    function spa_parlor_footer_content_widget(){
        
        $spa_parlor_default = spa_parlor_get_default_theme_options();
        
        $spa_parlor_footer_column_layout = absint(get_theme_mod('spa_parlor_footer_column_layout', $spa_parlor_default['spa_parlor_footer_column_layout']));
        $spa_parlor_footer_sidebar_class = 12;
        
        if($spa_parlor_footer_column_layout == 2) {
            $spa_parlor_footer_sidebar_class = 6;
        }
        
        if($spa_parlor_footer_column_layout == 3) {
            $spa_parlor_footer_sidebar_class = 4;
        }
        ?>
        
        <?php if ( get_theme_mod('spa_parlor_display_footer', true) == true ) : ?>
            <div class="footer-widgetarea">
                <div class="wrapper">
                    <div class="column-row">
                    
                        <?php for ($i = 0; $i < $spa_parlor_footer_column_layout; $i++) : ?>
                            
                            <div class="column <?php echo 'column-' . absint($spa_parlor_footer_sidebar_class); ?> column-sm-12">
                                
                                <?php 
                                // If no widgets are assigned, display default widgets
                                if ( ! is_active_sidebar( 'spa-parlor-footer-widget-' . $i ) ) : 

                                    if ($i === 0) : ?>
                                        <div id="media_image-3" class="widget widget_media_image">
                                            <img src="<?php echo esc_url(get_template_directory_uri() . '/assets/images/logo.png'); ?>" alt="<?php echo esc_attr__( 'Footer Image', 'spa-parlor' ); ?>" style="max-width: 100%; height: auto;">
                                        </div>
                                        <div id="text-3" class="widget widget_text">
                                            <div class="textwidget">
                                                <p class="widget_text">
                                                    <?php esc_html_e('The Spa Parlor Theme is designed for users who want a focused, visually appealing, and conversion-driven website without unnecessary complexity. Ideal for startups, product launches, digital services, and promotional campaigns, this theme helps you present your message clearly while keeping visitors engaged from the first scroll.', 'spa-parlor'); ?>
                                                </p>
                                            </div>
                                        </div>

                                    <?php elseif ($i === 1) : ?>
                                        <div id="pages-2" class="widget widget_pages">
                                            <h2 class="widget-title"><?php esc_html_e('Calendar', 'spa-parlor'); ?></h2>
                                            <?php get_calendar(); ?>
                                        </div>

                                    <?php elseif ($i === 2) : ?>
                                        <div id="search-2" class="widget widget_search">
                                            <h2 class="widget-title"><?php esc_html_e('Enter Keywords Here', 'spa-parlor'); ?></h2>
                                            <?php get_search_form(); ?>
                                        </div>
                                    <?php endif; 
                                    
                                else :
                                    // Display dynamic sidebar widget if assigned
                                    dynamic_sidebar('spa-parlor-footer-widget-' . $i);
                                endif;
                                ?>
                                
                            </div>
                            
                        <?php endfor; ?>

                    </div>
                </div>
            </div>
        <?php endif; ?> 

    <?php
    }

endif;

add_action( 'spa_parlor_footer_content_action', 'spa_parlor_footer_content_widget', 10 );

if( !function_exists('spa_parlor_footer_content_info') ):

    /**
     * Footer Copyright Area
    **/
    function spa_parlor_footer_content_info(){

        $spa_parlor_default = spa_parlor_get_default_theme_options(); ?>
        <div class="site-info">
            <div class="wrapper">
                <div class="column-row">

                    <div class="column column-9">
                        <div class="footer-credits">

                            <div class="footer-copyright">

                                <?php
                                $spa_parlor_footer_copyright_text = wp_kses_post( get_theme_mod( 'spa_parlor_footer_copyright_text', $spa_parlor_default['spa_parlor_footer_copyright_text'] ) );
                                    echo esc_html( $spa_parlor_footer_copyright_text );
                                    echo '<br>';

                                    echo esc_html__('Theme: ', 'spa-parlor') . '<a href="' . esc_url('https://www.omegathemes.com/products/spa-parlor') . '" title="' . esc_attr__('Spa Parlor ', 'spa-parlor') . '" target="_blank"><span>' . esc_html__('Spa Parlor  ', 'spa-parlor') . '</span></a>' . esc_html__(' By ', 'spa-parlor') . '  <span>' . esc_html__('OMEGA ', 'spa-parlor') . '</span>';
                                    echo esc_html__('Powered by ', 'spa-parlor') . '<a href="' . esc_url('https://wordpress.org') . '" title="' . esc_attr__('WordPress', 'spa-parlor') . '" target="_blank"><span>' . esc_html__('WordPress.', 'spa-parlor') . '</span></a>';
                                 ?>
                            </div>
                        </div>
                    </div>


                    <div class="column column-3 align-text-right">
                        <a class="to-the-top" href="#site-header">
                            <span class="to-the-top-long">
                                <?php if ( get_theme_mod('spa_parlor_enable_to_the_top', true) == true ) : ?>
                                    <?php
                                    $spa_parlor_to_the_top_text = get_theme_mod( 'spa_parlor_to_the_top_text', __( 'To the Top', 'spa-parlor' ) );
                                    printf( 
                                        wp_kses( 
                                            /* translators: %s is the arrow icon markup */
                                            '%s %s', 
                                            array( 'span' => array( 'class' => array(), 'aria-hidden' => array() ) ) 
                                        ), 
                                        esc_html( $spa_parlor_to_the_top_text ),
                                        '<span class="arrow" aria-hidden="true">&uarr;</span>' 
                                    );
                                    ?>
                                <?php endif; ?>
                            </span>
                        </a>

                    </div>
                </div>
            </div>
        </div>

    <?php
    }

endif;

add_action( 'spa_parlor_footer_content_action','spa_parlor_footer_content_info',20 );

if (!function_exists('spa_parlor_post_format_icon')):

    // Post Format Icon.
    function spa_parlor_post_format_icon() {

        $spa_parlor_format = get_post_format(get_the_ID()) ?: 'standard';
        $spa_parlor_icon = '';
        $spa_parlor_title = '';
        if( $spa_parlor_format == 'video' ){
            $spa_parlor_icon = spa_parlor_get_theme_svg( 'video' );
            $spa_parlor_title = esc_html__('Video','spa-parlor');
        }elseif( $spa_parlor_format == 'audio' ){
            $spa_parlor_icon = spa_parlor_get_theme_svg( 'audio' );
            $spa_parlor_title = esc_html__('Audio','spa-parlor');
        }elseif( $spa_parlor_format == 'gallery' ){
            $spa_parlor_icon = spa_parlor_get_theme_svg( 'gallery' );
            $spa_parlor_title = esc_html__('Gallery','spa-parlor');
        }elseif( $spa_parlor_format == 'quote' ){
            $spa_parlor_icon = spa_parlor_get_theme_svg( 'quote' );
            $spa_parlor_title = esc_html__('Quote','spa-parlor');
        }elseif( $spa_parlor_format == 'image' ){
            $spa_parlor_icon = spa_parlor_get_theme_svg( 'image' );
            $spa_parlor_title = esc_html__('Image','spa-parlor');
        } elseif( $spa_parlor_format == 'link' ){
            $spa_parlor_icon = spa_parlor_get_theme_svg( 'link' );
            $spa_parlor_title = esc_html__('Link','spa-parlor');
        } elseif( $spa_parlor_format == 'status' ){
            $spa_parlor_icon = spa_parlor_get_theme_svg( 'status' );
            $spa_parlor_title = esc_html__('Status','spa-parlor');
        } elseif( $spa_parlor_format == 'aside' ){
            $spa_parlor_icon = spa_parlor_get_theme_svg( 'aside' );
            $spa_parlor_title = esc_html__('Aside','spa-parlor');
        } elseif( $spa_parlor_format == 'chat' ){
            $spa_parlor_icon = spa_parlor_get_theme_svg( 'chat' );
            $spa_parlor_title = esc_html__('Chat','spa-parlor');
        }
        
        if (!empty($spa_parlor_icon)) { ?>
            <div class="theme-post-format">
                <span class="post-format-icom"><?php echo spa_parlor_svg_escape($spa_parlor_icon); ?></span>
                <?php if( $spa_parlor_title ){ echo '<span class="post-format-label">'.esc_html( $spa_parlor_title ).'</span>'; } ?>
            </div>
        <?php }
    }

endif;

if ( ! function_exists( 'spa_parlor_svg_escape' ) ):

    /**
     * Get information about the SVG icon.
     *
     * @param string $spa_parlor_svg_name The name of the icon.
     * @param string $group The group the icon belongs to.
     * @param string $color Color code.
     */
    function spa_parlor_svg_escape( $spa_parlor_input ) {

        // Make sure that only our allowed tags and attributes are included.
        $spa_parlor_svg = wp_kses(
            $spa_parlor_input,
            array(
                'svg'     => array(
                    'class'       => true,
                    'xmlns'       => true,
                    'width'       => true,
                    'height'      => true,
                    'viewbox'     => true,
                    'aria-hidden' => true,
                    'role'        => true,
                    'focusable'   => true,
                ),
                'path'    => array(
                    'fill'      => true,
                    'fill-rule' => true,
                    'd'         => true,
                    'transform' => true,
                ),
                'polygon' => array(
                    'fill'      => true,
                    'fill-rule' => true,
                    'points'    => true,
                    'transform' => true,
                    'focusable' => true,
                ),
            )
        );

        if ( ! $spa_parlor_svg ) {
            return false;
        }

        return $spa_parlor_svg;

    }

endif;

if( !function_exists( 'spa_parlor_sanitize_sidebar_option_meta' ) ) :

    // Sidebar Option Sanitize.
    function spa_parlor_sanitize_sidebar_option_meta( $spa_parlor_input ){

        $spa_parlor_metabox_options = array( 'global-sidebar','left-sidebar','right-sidebar','no-sidebar' );
        if( in_array( $spa_parlor_input,$spa_parlor_metabox_options ) ){

            return $spa_parlor_input;

        }else{

            return '';

        }
    }

endif;

if( !function_exists( 'spa_parlor_sanitize_pagination_meta' ) ) :

    // Sidebar Option Sanitize.
    function spa_parlor_sanitize_pagination_meta( $spa_parlor_input ){

        $spa_parlor_metabox_options = array( 'Center','Right','Left');
        if( in_array( $spa_parlor_input,$spa_parlor_metabox_options ) ){

            return $spa_parlor_input;

        }else{

            return '';

        }
    }

endif;

if( !function_exists( 'spa_parlor_sanitize_menu_transform' ) ) :

    // Sidebar Option Sanitize.
    function spa_parlor_sanitize_menu_transform( $spa_parlor_input ){

        $spa_parlor_metabox_options = array( 'capitalize','uppercase','lowercase');
        if( in_array( $spa_parlor_input,$spa_parlor_metabox_options ) ){

            return $spa_parlor_input;

        }else{

            return '';

        }
    }

endif;

if( !function_exists( 'spa_parlor_sanitize_page_content_alignment' ) ) :

    // Sidebar Option Sanitize.
    function spa_parlor_sanitize_page_content_alignment( $spa_parlor_input ){

        $spa_parlor_metabox_options = array( 'left','center','right');
        if( in_array( $spa_parlor_input,$spa_parlor_metabox_options ) ){

            return $spa_parlor_input;

        }else{

            return '';

        }
    }

endif;

if( !function_exists( 'spa_parlor_sanitize_footer_widget_title_alignment' ) ) :

    // Footer Option Sanitize.
    function spa_parlor_sanitize_footer_widget_title_alignment( $spa_parlor_input ){

        $spa_parlor_metabox_options = array( 'left','center','right');
        if( in_array( $spa_parlor_input,$spa_parlor_metabox_options ) ){

            return $spa_parlor_input;

        }else{

            return '';

        }
    }

endif;

if( !function_exists( 'spa_parlor_sanitize_pagination_type' ) ) :

    /**
     * Sanitize the pagination type setting.
     *
     * @param string $spa_parlor_input The input value from the Customizer.
     * @return string The sanitized value.
     */
    function spa_parlor_sanitize_pagination_type( $spa_parlor_input ) {
        // Define valid options for the pagination type.
        $spa_parlor_valid_options = array( 'numeric', 'newer_older' ); // Update valid options to include 'newer_older'

        // If the input is one of the valid options, return it. Otherwise, return the default option ('numeric').
        if ( in_array( $spa_parlor_input, $spa_parlor_valid_options, true ) ) {
            return $spa_parlor_input;
        } else {
            // Return 'numeric' as the fallback if the input is invalid.
            return 'numeric';
        }
    }

endif;


// Sanitize the enable/disable setting for pagination
if( !function_exists('spa_parlor_sanitize_enable_pagination') ) :
    function spa_parlor_sanitize_enable_pagination( $spa_parlor_input ) {
        return (bool) $spa_parlor_input;
    }
endif;

if( !function_exists( 'spa_parlor_sanitize_copyright_alignment_meta' ) ) :

    // Sidebar Option Sanitize.
    function spa_parlor_sanitize_copyright_alignment_meta( $spa_parlor_input ){

        $spa_parlor_metabox_options = array( 'Default','Reverse','Center');
        if( in_array( $spa_parlor_input,$spa_parlor_metabox_options ) ){

            return $spa_parlor_input;

        }else{

            return '';

        }
    }

endif;

/**
 * Sidebar Layout Function
 */
function spa_parlor_get_final_sidebar_layout() {
	$spa_parlor_defaults       = spa_parlor_get_default_theme_options();
	$spa_parlor_global_layout  = get_theme_mod('spa_parlor_global_sidebar_layout', $spa_parlor_defaults['spa_parlor_global_sidebar_layout']);
	$spa_parlor_page_layout    = get_theme_mod('spa_parlor_page_sidebar_layout', $spa_parlor_global_layout);
	$spa_parlor_post_layout    = get_theme_mod('spa_parlor_post_sidebar_layout', $spa_parlor_global_layout);
	$spa_parlor_meta_layout    = get_post_meta(get_the_ID(), 'spa_parlor_post_sidebar_option', true);

	if (!empty($spa_parlor_meta_layout) && $spa_parlor_meta_layout !== 'default') {
		return $spa_parlor_meta_layout;
	}
	if (is_page() || (function_exists('is_shop') && is_shop())) {
		return $spa_parlor_page_layout;
	}
	if (is_single()) {
		return $spa_parlor_post_layout;
	}
	return $spa_parlor_global_layout;
}